package bakalarka.mendelu.cz.bakamsg.dataModels;

import android.app.AlertDialog;
import android.app.Dialog;
import android.app.DialogFragment;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;

import bakalarka.mendelu.cz.bakamsg.FriendRequests;


public class SimpleDialogFragment extends DialogFragment{
    Context context;

    /**
     * Vytvoření Dialogového boxu, které se využívá u přijetí či odmítnutí Friend requestu.
     */
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceSaved){
        context = getActivity();
        final Bundle bundle = getArguments();
        AlertDialog.Builder dialogBuilder = new AlertDialog.Builder(context);
        dialogBuilder.setTitle("Friend Request");
        dialogBuilder.setMessage("User "+bundle.getString("userName")+" ("+bundle.getString("eMail")+") "+"has sent you a friend request.");
        dialogBuilder.setPositiveButton("Accept", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                FriendRequests.acceptedFriendRequest = "Yes";
                Log.w("Přijato","...");
                FriendRequests.friendRequestAccepted(
                        bundle.getString("UID"),bundle.getString("key"), bundle.getString("userName"),bundle.getString("eMail"));
            }
        });
        dialogBuilder.setNegativeButton("Decline", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                FriendRequests.acceptedFriendRequest = "No";
                Log.w("Nepřijato","...");
                FriendRequests.friendRequestDeclined(
                        bundle.getString("UID"),bundle.getString("key"));
            }
        });
        return dialogBuilder.create();
    }
}
