package bakamsgkinvey.cz.mendelu.bakalarka.bakamsgkinvey;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

import com.kinvey.android.AsyncAppData;
import com.kinvey.android.Client;
import com.kinvey.android.callback.KinveyListCallback;
import com.kinvey.java.Query;

import java.util.ArrayList;

import bakamsgkinvey.cz.mendelu.bakalarka.bakamsgkinvey.Adapters.FriendAdapter;
import bakamsgkinvey.cz.mendelu.bakalarka.bakamsgkinvey.dataModels.NewFriend;


public class FriendList extends AppCompatActivity {

    Client mKinveyClient;
    private final String TAG = "FriendListActivity";
    ListView friendList;
    FriendAdapter adapter;
    ProgressDialog progressDialog;
    final ArrayList<NewFriend> friends = new ArrayList<>();

    public String username;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_friend_list);
        friendList = (ListView)findViewById(R.id.list_friendlist);
        mKinveyClient = new Client.Builder(this.getApplicationContext()).build();

        username = UserpanelActivity.username;
        Log.w(TAG,"Username: "+username);

        progressDialog = new ProgressDialog(this);
        progressDialog.setMessage(getResources().getString(R.string.loading));
        progressDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        progressDialog.show();

        /**
         * Naplnění dat z Firebase přes Firebase adapter do připraveného listu.
         */
        Query q;
        Query query1 = new Query().equals("friend1",username);
        Query query2 = new Query().equals("friend2",username);
        q = query1.or(query2);
        AsyncAppData<NewFriend> data = mKinveyClient.appData("friends", NewFriend.class);
        data.get(q, new KinveyListCallback<NewFriend>() {
            @Override
            public void onSuccess(NewFriend[] friendsFound) {
                Log.w(TAG, "Pocet najitych " + friendsFound.length);
                for(int i=0; i<=friendsFound.length-1; i++){
                    friends.add(friendsFound[i]);
                }
                setAdapter();
            }
            @Override
            public void onFailure(Throwable t) {
                progressDialog.hide();
            }
        });

        friendList.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                openChatWithFriend(adapter.getItem(position));
            }
        });
    }

    public void setAdapter(){
        progressDialog.hide();
        adapter = new FriendAdapter(this, friends);
        friendList.setAdapter(adapter);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        progressDialog.dismiss();
    }
    /**
     * Otevření nové aktivity s chatovacím oknem mezi dvěma konkrétními uživateli.
     */
    private void openChatWithFriend(NewFriend fr){
        Context context = this;
        Intent i = new Intent(context, ChatWindowWithFriend.class);
        if (fr.getFriend1().equals(username)){
            i.putExtra("friendNick",fr.getFriend2());
            i.putExtra("myNick",fr.getFriend1());
            i.putExtra("chatWith",fr.getFriend2());
        } else {
            i.putExtra("friendNick",fr.getFriend1());
            i.putExtra("myNick",fr.getFriend2());
            i.putExtra("chatWith",fr.getFriend1());
        }
        i.setFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT);
        startActivity(i);
    }
}
