package bakamsgkinvey.cz.mendelu.bakalarka.bakamsgkinvey;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;

import com.kinvey.android.AsyncAppData;
import com.kinvey.android.AsyncUserDiscovery;
import com.kinvey.android.Client;
import com.kinvey.android.callback.KinveyDeleteCallback;
import com.kinvey.android.callback.KinveyListCallback;
import com.kinvey.android.callback.KinveyUserListCallback;
import com.kinvey.java.Query;
import com.kinvey.java.User;
import com.kinvey.java.core.KinveyClientCallback;
import com.kinvey.java.model.KinveyDeleteResponse;
import com.kinvey.java.model.UserLookup;

import java.util.ArrayList;

import bakamsgkinvey.cz.mendelu.bakalarka.bakamsgkinvey.Adapters.FriendRequestAdapter;
import bakamsgkinvey.cz.mendelu.bakalarka.bakamsgkinvey.dataModels.NewFriend;
import bakamsgkinvey.cz.mendelu.bakalarka.bakamsgkinvey.dataModels.NewFriendRequest;
import bakamsgkinvey.cz.mendelu.bakalarka.bakamsgkinvey.dataModels.SimpleDialogFragment;


public class FriendRequests extends AppCompatActivity {

    static public String acceptedFriendRequest;
    static Client mKinveyClient;

    private static final String TAG = "FriendRequest";

    ListView listOfFriendsReq;
    Button buttonSendReq;
    EditText editTextNewRequest;
    static ProgressDialog progressDialog;

    static ArrayList<NewFriendRequest> frRequests = new ArrayList<>();
    static FriendRequestAdapter adapter;
    static Context context;

    String username;
    String email;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_friend_requests);
        mKinveyClient = new Client.Builder(this.getApplicationContext()).build();
        context = this;

        listOfFriendsReq = (ListView)findViewById(R.id.fr_list_req);
        buttonSendReq = (Button)findViewById(R.id.button_fr_req);
        editTextNewRequest = (EditText)findViewById(R.id.editTextNewRequest);

        progressDialog = new ProgressDialog(this);
        progressDialog.setMessage(getResources().getString(R.string.loading));
        progressDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);

        Intent i = getIntent();
        username = i.getStringExtra("username");
        email = i.getStringExtra("email");

        buttonSendReq.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                sendNewRequest();
            }
        });
        progressDialog.show();

        Query q = mKinveyClient.query();
        q.equals("targetUsername",username);
        AsyncAppData<NewFriendRequest> data = mKinveyClient.appData("friendrequests", NewFriendRequest.class);
        data.get(q, new KinveyListCallback<NewFriendRequest>() {
            @Override
            public void onSuccess(NewFriendRequest[] newFriendRequests) {

                Log.w(TAG, "Pocet najitych " + newFriendRequests.length);
                for(int i=0; i<=newFriendRequests.length-1; i++){
                    frRequests.add(newFriendRequests[i]);
                }
                setAdapter();
            }

            @Override
            public void onFailure(Throwable t) {
                progressDialog.hide();
            }
        });
        /**
         * Příprava na předání potřebných informací k přijetí nebo odmítnutí požadavku o přijetí do přátel.
         * Následně se zobrazí dialogový box.
         */
        listOfFriendsReq.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Bundle bundle = new Bundle();
                NewFriendRequest nFr = adapter.getItem(position);
                Log.w(TAG, "Kliknul jsem na " + nFr.getSourceUsername());
                bundle.putString("username1",nFr.getSourceUsername());
                bundle.putString("username2",username);
                bundle.putString("user1mail",nFr.getSourceEmail());
                bundle.putString("user2mail",email);
                bundle.putString("UID",nFr.getId());
                bundle.putInt("pos",position);
                Log.v(TAG, "UID " + nFr.getId());

                SimpleDialogFragment fragment = new SimpleDialogFragment();
                fragment.setArguments(bundle);
                fragment.show(getFragmentManager(),"Dialog");
            }
        });
    }
    /**
     * Naplnění dat z Kinveyho přes adapter do připraveného listu.
     */
    public void setAdapter(){
        adapter = new FriendRequestAdapter(this, frRequests);
        listOfFriendsReq.setAdapter(adapter);
        progressDialog.hide();
    }

    /**
     * Odeslání nového požadavku o přidání do přátel s konkrétním username do databáze.
     * Než může transakce proběhnout, zkontroluje se, jestli daný uživatel existuje.
     * V případě že ano, vše proběhne hladce.
     * V případě, že je zadán username aktuálně přihlášeného užřivatele, vypíše se o této skutečnosti informace.
     * A v případě, že uživatel se zadaným username v databázi není, je přihlášený uživatel informován.
     */
    private void sendNewRequest(){
        final String usernameFromEdit = editTextNewRequest.getText().toString();
        editTextNewRequest.setText("");

        if (TextUtils.isEmpty(usernameFromEdit)){
            editTextNewRequest.setError(getResources().getString(R.string.required));
        } else if (!usernameFromEdit.equals(username)) {
            progressDialog.show();

            AsyncUserDiscovery users = mKinveyClient.userDiscovery();
            UserLookup criteria = users.userLookup();
            criteria.setUsername(usernameFromEdit);
            users.lookup(criteria, new KinveyUserListCallback() {
                @Override
                public void onSuccess(User[] result) {
                    Log.v(TAG, "Nalezeno " + result.length + " users");
                    if (result.length!=0){
                        Log.v(TAG, "Nalezeno " + result[0].getUsername());

                        NewFriendRequest fr = new NewFriendRequest(username,result[0].getUsername(),email);
                        AsyncAppData<NewFriendRequest> frs = mKinveyClient.appData("friendrequests",NewFriendRequest.class);
                        frs.save(fr, new KinveyClientCallback<NewFriendRequest>() {
                            @Override
                            public void onSuccess(NewFriendRequest newFriendRequest) {
                                Toast.makeText(getApplicationContext(), "Request has been sent.", Toast.LENGTH_SHORT).show();
                                Log.e("TAG", "Data ulozena.");
                                progressDialog.hide();
                            }
                            @Override
                            public void onFailure(Throwable e) {
                                Log.e("TAG", "Nepodarilo se ulozit friend request data", e);
                                progressDialog.hide();
                            }
                        });
                    } else {
                        Toast.makeText(getApplicationContext(), "This username does not exists.", Toast.LENGTH_SHORT).show();
                        progressDialog.hide();
                    }
                }
                @Override
                public void onFailure(Throwable error) {
                    Log.v(TAG, "prijato " + error);
                    progressDialog.hide();
                }
            });
        } else {
            Toast.makeText(getApplicationContext(), "You can't send request to your own.", Toast.LENGTH_SHORT).show();
        }
    }
    /**
     * Přijetí požadavku o přidání do přátel a přidání záznamu do databáze.
     */
    public static void friendRequestAccepted(String friend1, String friend2, int pos, String UID, String friend1Email, String friend2Email){
        final int position = pos;
        final String ID = UID;
        NewFriend fr = new NewFriend(friend1,friend2,friend1Email,friend2Email);
        AsyncAppData<NewFriend> frs = mKinveyClient.appData("friends",NewFriend.class);
        frs.save(fr, new KinveyClientCallback<NewFriend>() {
            @Override
            public void onSuccess(NewFriend newFriendRequest) {
                Toast.makeText(context, "Friend request has been accepted.", Toast.LENGTH_SHORT).show();
                Log.e("TAG", "Data ulozena.");
                deleteFrReq(ID, position);
                progressDialog.hide();
            }
            @Override
            public void onFailure(Throwable e) {
                Toast.makeText(context, "There was an error.", Toast.LENGTH_SHORT).show();
                Log.e("TAG", "Nepodarilo se ulozit friend data", e);
                progressDialog.hide();
            }
        });
    }
    /**
     * Odstranění požadavko o přidání do přátel po jeho přijetí.
     */
    public static void deleteFrReq(String UID, int pos){
        final int position = pos;
        AsyncAppData<NewFriendRequest> frs = mKinveyClient.appData("friendrequests", NewFriendRequest.class);
        frs.delete(UID, new KinveyDeleteCallback() {
            @Override
            public void onSuccess(KinveyDeleteResponse response) {
                frRequests.remove(position);
                adapter.notifyDataSetChanged();
                Log.w(TAG, "Záznam byl smazán.");
            }
            public void onFailure(Throwable error) {
                Log.w(TAG, "Záznam nebyl smazán. ", error);
            }
        });
    }

    /**
     * Odmítnutí požadavku o přijetí do přátel.
     */
    public static void friendRequestDeclined(String UID, int pos){
        final int position = pos;
        AsyncAppData<NewFriendRequest> frs = mKinveyClient.appData("friendrequests", NewFriendRequest.class);
        frs.delete(UID, new KinveyDeleteCallback() {
            @Override
            public void onSuccess(KinveyDeleteResponse response) {
                frRequests.remove(position);
                adapter.notifyDataSetChanged();
                Toast.makeText(context, "Friend request has been declined.", Toast.LENGTH_SHORT).show();
                Log.w(TAG, "Záznam byl smazán.");
            }
            public void onFailure(Throwable error) {
                Log.w(TAG, "Záznam nebyl smazán. ", error);
            }
        });
    }

    public void onDestroy(){
        super.onDestroy();
        progressDialog.dismiss();
    }
}