package bakamsgkinvey.cz.mendelu.bakalarka.bakamsgkinvey;

import android.app.ProgressDialog;
import android.support.v7.app.AppCompatActivity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Button;
import android.widget.TextView;

import com.kinvey.android.Client;
import com.kinvey.android.callback.KinveyUserCallback;
import com.kinvey.java.User;

public class UserpanelActivity extends AppCompatActivity {

    private static final String TAG = "UserPanelActivity";
    private TextView textViewShowUser;
    private Button buttonFriend;
    private Button buttonDiscussions;
    private Button buttonFriendRequests;
    ProgressDialog progressDialog;

    Client mKinveyClient;
    public static String username;
    String email;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_usrpanel);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        mKinveyClient = new Client.Builder(this.getApplicationContext()).build();
        textViewShowUser = (TextView) findViewById(R.id.textViewLoggedUser);
        buttonDiscussions = (Button) findViewById(R.id.buttonDiscussion);
        buttonFriend = (Button) findViewById(R.id.buttonFriends);
        buttonFriendRequests = (Button) findViewById(R.id.buttonFriendReq);

        progressDialog = new ProgressDialog(this);
        progressDialog.setMessage("Loading user data.");
        progressDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        progressDialog.show();

        mKinveyClient.user().retrieve(new KinveyUserCallback() {
            @Override
            public void onFailure(Throwable e) {
                progressDialog.hide();
            }
            @Override
            public void onSuccess(User user) {
                textViewShowUser.setText(getString(R.string.logged)+" "+user.get("username"));
                username = user.get("username").toString();
                email = user.get("email").toString();
                progressDialog.hide();
            }
        });

        buttonFriend.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                goToAnotherActivity("FriendsActivity");
            }
        });
        buttonDiscussions.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                goToAnotherActivity("DiscussionsActivity");
            }
        });
        buttonFriendRequests.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                goToAnotherActivity("FriendRequestsActivity");
            }
        });
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onStop() {
        super.onStop();
    }

    @Override
    public void onResume() {
        super.onResume();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        progressDialog.dismiss();
    }
    /**
     * Rozcestník.
     */
    private void goToAnotherActivity(String activity){
        Context context = this;
        Intent i = null;
        switch (activity) {
            case "FriendsActivity":
                i = new Intent(context, FriendList.class);
                break;
            case "FriendRequestsActivity":
                i = new Intent(context, FriendRequests.class);
                i.putExtra("username",username);
                i.putExtra("email",email);
                break;
            case "DiscussionsActivity":
                i = new Intent(context, Discussions.class);
                break;
        }
        i.setFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT);
        startActivity(i);
    }

    /**
     * Zakázání funkce jít zpět v zařízení – důvodem je nemožnost vrátit se zpět do Login activity jinak než přes korektní odhlášení se ze služby.
     */
    @Override
    public void onBackPressed() {
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.userpanel, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_logout) {
            signOut();
        }
        return super.onOptionsItemSelected(item);
    }

    /**
     * Odhlášení ze služby.
     */
    private void signOut(){
        mKinveyClient.user().logout().execute();
        Intent result = new Intent();
        result.putExtra("Logged-out",true);
        setResult(3,result);
        finish();
    }
}
